#include <iostream>
#include <list>

using namespace std;

class Graph {
    int N;
    list<int> *neighbors;

public:
    Graph(int N);
    void addEdge(int v, int w);
    void DFS(int s);
};

Graph::Graph(int N) {
    this->N = N;
    neighbors = new list<int>[N];
}

void Graph::addEdge(int v, int w) {
    neighbors[v].push_back(w);
}

void Graph::DFS(int s) {
    bool *visited = new bool[N];
    for (int i = 0; i < N; i++) {
        visited[i] = false;
    }
    
    list<int> toVisit;
    list<int>::iterator ni; // neighborIterator
    visited[s] = true;
    toVisit.push_back(s);
    
    while (!toVisit.empty()) {
        s = toVisit.back();
        cout << s << " ";
        toVisit.pop_back();
        for (ni = neighbors[s].begin(); ni != neighbors[s].end(); ++ni) {
            if (!visited[*ni]) {
                visited[*ni] = true;
                toVisit.push_back(*ni);
            }
        }
    }
}

int main()
{
    Graph g(5);
    g.addEdge(3, 3);
    g.addEdge(3, 2);
    g.addEdge(2, 1);
    g.addEdge(2, 0);
    g.addEdge(1, 0);
    g.addEdge(0, 2);
    g.addEdge(1, 4);
    g.addEdge(1, 3);
    g.DFS(0);
    return 0;
}